package com.tzld.piaoquan.recommend.server.service.rank.extractor;

import com.tzld.piaoquan.recommend.server.model.Video;
import com.tzld.piaoquan.recommend.server.service.FeatureService;
import com.tzld.piaoquan.recommend.server.service.ServiceBeanFactory;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class RankExtractorForPostProcessor {

    public static void fullMergeCate2FromFeature(List<Video> rovList, List<Video> flowVideos) {

        FeatureService featureService = ServiceBeanFactory.getBean(FeatureService.class);

        List<String> vidStrList = new ArrayList<>(rovList.size() + flowVideos.size());
        rovList.stream().map(v -> String.valueOf(v.getVideoId())).forEach(vidStrList::add);
        flowVideos.stream().map(v -> String.valueOf(v.getVideoId())).forEach(vidStrList::add);

        Map<String, Map<String, Map<String, String>>> featureMap = featureService.getVideoBaseInfo("", vidStrList);

        parseAndSetMergeCate2(rovList, featureMap);
        parseAndSetMergeCate2(flowVideos, featureMap);
    }

    private static void parseAndSetMergeCate2(List<Video> videos, Map<String, Map<String, Map<String, String>>> featureMap) {
        for (Video video : videos) {
            String vidStr = String.valueOf(video.getVideoId());
            if (!featureMap.containsKey(vidStr)) {
                continue;
            }

            Map<String, Map<String, String>> vidFeature = featureMap.get(vidStr);
            if (!vidFeature.containsKey("alg_vid_feature_basic_info")) {
                continue;
            }

            Map<String, String> basicInfoMap = vidFeature.get("alg_vid_feature_basic_info");
            String mergeCate2 = basicInfoMap.getOrDefault("merge_second_level_cate", "");
            if (StringUtils.isNotBlank(mergeCate2)) {
                video.getMergeCateList().add(mergeCate2);
            }
        }
    }
}
